import math
import time
from fischertechnik.controller.Motor import Motor
from lib.controller import *

sp = None
cm = None
deg = None
calib_move = None
speed = None
calib_rotation = None


def stop_async():
    global sp, cm, deg, calib_move, speed, calib_rotation
    TXT_M_M1_encodermotor.stop()
    TXT_M_M2_encodermotor.stop()


def forward_async():
    global sp, cm, deg, calib_move, speed, calib_rotation
    TXT_M_M1_encodermotor.set_speed(int(speed), Motor.CCW)
    TXT_M_M1_encodermotor.start()
    TXT_M_M2_encodermotor.set_speed(int(speed), Motor.CCW)
    TXT_M_M2_encodermotor.start()


def forward_m1_async():
    global sp, cm, deg, calib_move, speed, calib_rotation
    TXT_M_M1_encodermotor.set_speed(int(speed), Motor.CCW)
    TXT_M_M1_encodermotor.start()
    TXT_M_M2_encodermotor.set_speed(int(0), Motor.CCW)
    TXT_M_M2_encodermotor.start()


def forward_m2_async():
    global sp, cm, deg, calib_move, speed, calib_rotation
    TXT_M_M1_encodermotor.set_speed(int(0), Motor.CCW)
    TXT_M_M1_encodermotor.start()
    TXT_M_M2_encodermotor.set_speed(int(speed), Motor.CCW)
    TXT_M_M2_encodermotor.start()


def backward_async():
    global sp, cm, deg, calib_move, speed, calib_rotation
    TXT_M_M1_encodermotor.set_speed(int(speed), Motor.CW)
    TXT_M_M1_encodermotor.start()
    TXT_M_M2_encodermotor.set_speed(int(speed), Motor.CW)
    TXT_M_M2_encodermotor.start()


def rotate_left_async():
    global sp, cm, deg, calib_move, speed, calib_rotation
    TXT_M_M1_encodermotor.set_speed(int(speed), Motor.CCW)
    TXT_M_M1_encodermotor.start()
    TXT_M_M2_encodermotor.set_speed(int(speed), Motor.CW)
    TXT_M_M2_encodermotor.start()


def rotate_right_async():
    global sp, cm, deg, calib_move, speed, calib_rotation
    TXT_M_M1_encodermotor.set_speed(int(speed), Motor.CW)
    TXT_M_M1_encodermotor.start()
    TXT_M_M2_encodermotor.set_speed(int(speed), Motor.CCW)
    TXT_M_M2_encodermotor.start()


def init_calib_motor():
    global sp, cm, deg, calib_move, speed, calib_rotation
    calib_move = 6.473
    calib_rotation = 0.896
    speed = 400


def set_speed(sp):
    global cm, deg, calib_move, speed, calib_rotation
    speed = sp


def stop_sync():
    global sp, cm, deg, calib_move, speed, calib_rotation
    TXT_M_M1_encodermotor.stop_sync(TXT_M_M2_encodermotor)


def forward_sync(cm):
    global sp, deg, calib_move, speed, calib_rotation
    if cm >= 0:
        TXT_M_M1_encodermotor.set_speed(int(speed), Motor.CCW)
        TXT_M_M2_encodermotor.set_speed(int(speed), Motor.CCW)
        TXT_M_M1_encodermotor.set_distance(int(cm * calib_move), TXT_M_M2_encodermotor)
        while True:
            if ((not TXT_M_M1_encodermotor.is_running()) and (not TXT_M_M2_encodermotor.is_running())):
                break
            time.sleep(0.010)
    else:
        TXT_M_M1_encodermotor.set_speed(int(speed), Motor.CCW)
        TXT_M_M2_encodermotor.set_speed(int(speed), Motor.CCW)
        TXT_M_M1_encodermotor.start_sync(TXT_M_M2_encodermotor)


def backward_sync(cm):
    global sp, deg, calib_move, speed, calib_rotation
    if cm >= 0:
        TXT_M_M1_encodermotor.set_speed(int(speed), Motor.CW)
        TXT_M_M2_encodermotor.set_speed(int(speed), Motor.CW)
        TXT_M_M1_encodermotor.set_distance(int(cm * calib_move), TXT_M_M2_encodermotor)
        while True:
            if ((not TXT_M_M1_encodermotor.is_running()) and (not TXT_M_M2_encodermotor.is_running())):
                break
            time.sleep(0.010)
    else:
        TXT_M_M1_encodermotor.set_speed(int(speed), Motor.CW)
        TXT_M_M2_encodermotor.set_speed(int(speed), Motor.CW)
        TXT_M_M1_encodermotor.start_sync(TXT_M_M2_encodermotor)


def turn_sync(deg):
    global sp, cm, calib_move, speed, calib_rotation
    if deg > 0:
        TXT_M_M1_encodermotor.set_speed(int(speed), Motor.CCW)
        TXT_M_M2_encodermotor.set_speed(int(speed), Motor.CW)
        TXT_M_M1_encodermotor.set_distance(int(deg * calib_rotation), TXT_M_M2_encodermotor)
        while True:
            if ((not TXT_M_M1_encodermotor.is_running()) and (not TXT_M_M2_encodermotor.is_running())):
                break
            time.sleep(0.010)
    elif deg < 0:
        TXT_M_M1_encodermotor.set_speed(int(speed), Motor.CW)
        TXT_M_M2_encodermotor.set_speed(int(speed), Motor.CCW)
        TXT_M_M1_encodermotor.set_distance(int(math.fabs(deg * calib_rotation)), TXT_M_M2_encodermotor)
        while True:
            if ((not TXT_M_M1_encodermotor.is_running()) and (not TXT_M_M2_encodermotor.is_running())):
                break
            time.sleep(0.010)
    else:
        pass
